﻿using System.Linq;
using System.Windows;
using System.Windows.Documents;
using System.Windows.Input;
using Microsoft.Windows.Controls;
using System.Data.Linq;

namespace CRUDDataGridWPF
{
    public partial class Window1 : Window
    {
        #region Constructor
        public Window1()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(Window1_Loaded);
        } 
        #endregion

        #region Leitura
        void Window1_Loaded(object sender, RoutedEventArgs e)
        {
            ProdutosDataContext context = new ProdutosDataContext();
            var resultado = from p in context.Produtos
                            select p;

            if (resultado.ToList().Count > 0)
            {
                txtStatus.Text = "Produtos lidos com sucesso.";
            }
            
            dgData.ItemsSource = resultado.ToList();
        }
        #endregion

        #region Criar e Atualizar
        private void dgData_RowEditEnding(object sender, DataGridRowEditEndingEventArgs e)
        {
            if (e.EditAction == DataGridEditAction.Commit)
            {
                ProdutosDataContext context = new ProdutosDataContext();
                Produto p = e.Row.DataContext as Produto;

                var resultado = (from prd in context.GetTable<Produto>()
                                 where prd.id == p.id
                                 select prd).SingleOrDefault();

                if (resultado == null)
                {
                    Table<Produto> pTabela = context.GetTable<Produto>();

                    Produto produto = new Produto();
                    produto.nome = p.nome;
                    produto.preco = p.preco;

                    pTabela.InsertOnSubmit(produto);
                    pTabela.Context.SubmitChanges();

                    txtStatus.Text = "Dados Incluidos com sucesso";
                }
                else
                {
                    resultado.nome = p.nome;
                    resultado.preco = p.preco;
                    context.SubmitChanges();

                    txtStatus.Text = "Dados atualizados com sucesso";
                }
            }
        } 
        #endregion

        #region Exclusão
        private void dgData_PreviewExecuted(object sender, ExecutedRoutedEventArgs e)
        {
            ProdutosDataContext context = new ProdutosDataContext();
            Produto produto = dgData.SelectedItem as Produto;
            
            if (produto != null)
            {
                var produtoEncontrado = (from p in context.GetTable<Produto>()
                                         where p.id == produto.id
                                         select p).SingleOrDefault();

                if (e.Command == DataGrid.DeleteCommand)
                {
                    if (!(MessageBox.Show("Deseja excluir o registro selecionado ?", 
                        "Confirma Exclusão !", MessageBoxButton.YesNo) == MessageBoxResult.Yes))
                    {
                        e.Handled = true;
                    }
                    else
                    {
                        context.Produtos.DeleteOnSubmit(produtoEncontrado);
                        context.SubmitChanges();
                        txtStatus.Text = "Dados excluídos com sucesso.";
                    }
                }
            }
        }
        #endregion
    }
}
